petsc-3.7.1 2016-05-15
Report Typos and Errors

# MatZeroRowsColumns

Zeros all entries (except possibly the main diagonal) of a set of rows and columns of a matrix.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode MatZeroRowsColumns(Mat mat,PetscInt numRows,const PetscInt rows[],PetscScalar diag,Vec x,Vec b)

Collective on Mat Many br

### Input Parameters

| mat | - the matrix Many br
| numRows | - the number of rows to remove Many br
| rows | - the global row indices Many br
| diag | - value put in all diagonals of eliminated rows (0.0 will even eliminate diagonal entry) Many br
| x | - optional vector of solutions for zeroed rows (other entries in vector are not used) Many br
| b | - optional vector of right hand side, that will be adjusted by provided solution Many br

### Notes

This does not change the nonzero structure of the matrix, it merely zeros those entries in the matrix. Many br

The user can set a value in the diagonal entry (or for the AIJ and Many brrow formats can optionally remove the main diagonal entry from the Many brnonzero structure as well, by passing 0.0 as the final argument). Many br

For the parallel case, all processes that share the matrix (i.e., Many brthose in the communicator used for matrix creation) MUST call this Many brroutine, regardless of whether any rows being zeroed are owned by Many brthem. Many br

Each processor can indicate any rows in the entire matrix to be zeroed (i.e. each process does NOT have to Many brlist only rows local to itself). Many br

The option MAT_NO_OFF_PROC_ZERO_ROWS does not apply to this routine. Many br

Many br

### See Also

MatZeroRowsIS(), MatZeroRowsStencil(), MatZeroEntries(), MatZeroRowsLocal(), MatSetOption(), MatZeroRowsColumnsIS()

Level:intermediate
Location:src/mat/interface/matrix.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/ksp/ksp/examples/tutorials/ex43.c.html